#include <cstdlib>
#include <cmath>
#include <iostream>
#include <rdbxx/RDB.h>

using namespace std;

// Trivial filter program.  Copy input RDB file to output RDB file.
int main( int argc, char* argv[] ) {
  try {
    RDB irdb( &cin  );
    RDB ordb( &cout );

    int idx;
    // Copy all the comments...
    for ( idx = 0; idx < irdb.nComments( ); idx++ ) 
      ordb.setComment( irdb.getComment( idx ) );

    // Copy all the columns...
    for ( idx = 0; idx < irdb.nColumns( ); idx++ ) 
      ordb.setColumn( irdb.getColumn( idx ) );

    // Read the data...
    while ( irdb.read( ) ) 
      // And write it out...
      ordb.write( );

  // See if RDB failed...
  } catch ( RDBErr& re ) {
    cerr << "Caught an RDBErr object" << endl;
    cerr << re << endl;
    return EXIT_FAILURE;

  // See if anything else failed...
  } catch ( exception& e ) { 
    cerr << "Caught an exception object" << endl;
    cerr << e.what( ) << endl;
    return EXIT_FAILURE;

  // And just in case you missed something...
  } catch ( ... ) {
    cerr << "Caught something unexpected..." << endl;
    return EXIT_FAILURE;

  }

  return EXIT_SUCCESS;
}
