#include <cstdlib>
#include <iostream>
#include <string>
#include <vector>
#include <rdbxx/RDB.h>
//
//
// Broken...
//
//
using namespace std;

// Using group columns, find the min and max values as well as the
// number of elements in a group.
int main( int argc, char* argv[] ) {

  try {
    // Set up input and output files...
    RDB irdb( &cin );
    RDB ordb( &cout );

    // Get the number of input columns...
    size_t nColumns       = irdb.nColumns( );

    // Set up index lookups for the output columns...
    vector<int> min(nColumns), max(nColumns), cnt(nColumns);

    // Foreach input column...
    for ( size_t idx = 0; idx < nColumns; idx++ ) {
      string name = irdb.getName( idx );
      string def  = irdb.getDef(  idx );

      // If its numeric, setup the min, max, and count column...
      if ( RDBColumn::NUMERIC == irdb.getType( idx ) ) {
	// Create a min, max, and count column foreach numeric input column...
	ordb.setColumn( name  + "_min", def );
	ordb.setColumn( name  + "_max", def );
	ordb.setColumn( name  + "_cnt", def );

	min[idx] = ordb.nColumns( ) - 3;
	max[idx] = ordb.nColumns( ) - 2;
	cnt[idx] = ordb.nColumns( ) - 1;
	
      // Else assume its a break column...
      } else {
	// Set up a group on any non-numeric field...
	irdb.setGroup( idx );
	ordb.setColumn( irdb.getColumn( idx ) );
	
      }
    }
    
    int stat;
    // Read the input...
    while ( stat = irdb.read( ) ) {

      // Beginning of a group...
      if ( RDB::RBOG & stat ) {
	for ( size_t idx = 0; idx < nColumns; idx++ ) {
	  if ( RDBColumn::NUMERIC == irdb.getType( idx ) ) {
	    ordb.setData( min[idx], irdb.getDataDouble( idx ) );
	    ordb.setData( max[idx], irdb.getDataDouble( idx ) );
	    ordb.setData( cnt[idx], 1.0 );
	    
	  }
	}
      // Middle of a group...
      } else {
	for ( size_t idx = 0; idx < nColumns; idx++ ) {
	  double val;
	  // Keep accumulating stats...
	  if ( RDBColumn::NUMERIC == irdb.getType( idx ) ) {
	    if ( ordb.getDataDouble( min[idx] ) > (val = irdb.getDataDouble( idx )) )
	      ordb.setData( min[idx], val );
	    if ( ordb.getDataDouble( max[idx] ) < (val = irdb.getDataDouble( idx )) )
	      ordb.setData( max[idx], val );

	    ordb.setData( cnt[idx], ordb.getDataDouble( cnt[idx] ) + 1 );
	    
	  }
	}
      }

      // End of a group...
      if ( RDB::REOG & stat ) {
	ordb.write( );

      }
    }
  } catch ( RDBErr& re ) {
    cerr << "RDBErr:" << endl << re << endl;
    return EXIT_FAILURE;
    
  } catch ( Exception& E ) {
    cerr << "Exception:" << endl << E << endl;
    return EXIT_FAILURE;

  } catch ( exception& e ) {
    cerr << "exception:" << endl << e.what( ) << endl;
    return EXIT_FAILURE;
    
  } catch ( ... ) {
    cerr << "Caught something unexpected..." << endl;
    return EXIT_FAILURE;

  }

  return EXIT_SUCCESS;
}
