#include <cstdlib>
#include <cerrno>
#include <iostream>
#include <testlib/testlib.h>
#include <rdbxx/RDBColumnTmplt.h>
#include <rdbxx/RDBErr.h>

using namespace std;

int main( int argc, char* argv[] ) {
  START( "RDBColumn Data Test Suite" );
  
  string name( "my column name" );
  string def( "15N< What description?" );
  RDBStringColumn c1( name, def );

  TEST( "RDBColumn::getName( )",  c1.getName( ),  name );
  TEST( "RDBColumn::getDef( )",   c1.getDef( ),   def );

  const char* cptr_data = "1.1";
  double dbl_data = 1.1;
  long lng_data = 1;
  string str_data = cptr_data;
  c1.setData( cptr_data );
  TESTSTRING( "RDBColumn::getData( )", c1.getDataString( ).c_str( ), cptr_data );
  TEST( "RDBColumn::getDataDouble( )", c1.getDataDouble( ), dbl_data );
  bool caught = false;
  try {
    c1.getDataLong( );
  } catch ( RDBErr& re ) {
    caught = true;
  } catch ( ... ) { 
    caught = false;
  }
  TEST( "RDBColumn::getDataLong( )", caught, true );
  c1.setThrow( false );
  TEST( "RDBColumn::getDataLong( )", c1.getDataLong( ), lng_data );
  TEST( "RDBColumn::getDataLong( )", c1.getErrNo( ), RDBColumn::LOSTPRECISION );
  TEST( "RDBColumn::getDataString( )", c1.getDataString( ), str_data );

  SUMMARY( );
  
  return FAILED( ) ? EXIT_FAILURE : EXIT_SUCCESS;
}
